# -----(Description)----------------------------------------------------------
# New Filebase Lister v1.0 By Darryl Perry, 2003.  A Cyberia BBS Production
#
# New Filebase Lister (NFB) is a script that will show the latest filebases
# that were added since the users' last login.  
#
# Although this program is entered into the public domain, please give 
# credit where credit is due.  If you use this program, or portions thereof,
# please give due credit.
#
# More information can be found in the Sysop.txt file of the gy-nfb10.zip file
# ---------------------------------------------------------------------------
Uses CFG
Uses User
Uses Fbase

Const	ProgName	=	'New File Area Lister'
Const	ProgAuth	=	'Darryl Perry, 2003'
Const	DatFile		=	'newfb.dat'
Const	OldFile 	=	'oldfb.dat'

Var I1		Integer
Var I5		Integer
Var	F1		String
Var F2 		String
Var FBFile	String
Var Datet	String
Var TFBFile	String
Var TDateT	String
Var ULaston	String
Var UFirst	String
var InitFlg Integer
Var found	Byte
Var Dayx	Integer Array (1..12)
Var Day1	Word	
Var Day2	Word	
Var Day0	Word	
Var DayA	Word	

GetThisUser
GetCfg

Procedure InitVars
Begin
	ULaston:=DateStr(UserLast,1)
	UFirst:=DateStr(UserFirst,1)
	F1:=CfgDataPath+DatFile
	F2:=CfgDataPath+OldFile
	InitFlg:=0
	If fExist(F1)	Then
		InitFlg:=1
	Endif
	Dayx(1):=0				# January
	Dayx(2):=Dayx(1)+31		# Feburary
	Dayx(3):=Dayx(2)+30		# March
	Dayx(4):=Dayx(3)+31		# April
	Dayx(5):=Dayx(4)+30		# May
	Dayx(6):=Dayx(5)+31		# June
	Dayx(7):=Dayx(6)+30		# July
	Dayx(8):=Dayx(7)+31		# August
	Dayx(9):=Dayx(8)+31		# September
	Dayx(10):=Dayx(8)+30		# October
	Dayx(11):=Dayx(10)+31		# November
	Dayx(12):=Dayx(11)+30		# December

Pend

Procedure SaveData
Begin
	if not fExist(F1) then
		fOpen(1,Text,ReWrite,F1)
	Else
		fOpen(1,text,Append,F1)
	Endif
	fWriteLn(1,FBFile)
	fWriteLn(1,DateT)
	fClose(1)
Pend

Procedure WeedOut
Begin
	fOpen(1,Text,Reset,F1)
	fOpen(2,Text,ReWrite,F2)
	While Not Eof(1)
		fReadLn(1,TFBFile)
		fReadLn(1,TDateT)
		I1:=1
		While GetFBase(I1)
			If TFBFile = FBFileName Then
				fWriteLn(2,TFBFile)
				fWriteLn(2,TDateT)
			Endif
			I1:=I1+1
		Wend
	Wend
	fClose(1)
	fClose(2)
	If fExist(F1) Then fErase(F1) endif
	If fExist(F2) Then If fCopy(F2,F1) Then Endif Endif
	If fExist(F2) Then fErase(F2) Endif
Pend

Function CheckFB : Integer
Var I2	Integer
Begin
	I2:=0
	if fExist(F1) Then
		fOpen(1,Text,Reset,F1)
		While not eof(1)
			fReadLn(1,TFBFile)
			fReadLn(1,TDateT)
			if TFBFile = FBFile Then
				I2:=1
			Endif
		Wend
		fClose(1)
	Endif
	CheckFB:=I2
Pend

Procedure FindNewFBs
Begin
	I1:=1
	While GetFBase(I1)
		FBFile:=FBFileName
		If CheckFB = 0 Then
			If InitFlg = 0
				DateT:='01/01/80'
			else
				DateT:=DateStr(DateTime,1)
			Endif
			SaveData
		Endif	
		I1:=I1+1
	Wend
Pend

Function Date2Days( Date1 String) : Word
Var I4	Word	
Var Yr	Integer	
var Mo	Integer	
Var Da	Integer	
Begin
		Yr:=Str2Int(Copy(Date1,7,2))
		Da:=Str2Int(Copy(Date1,4,2))
		Mo:=Str2Int(Copy(Date1,1,2))
		If Yr < 70 Then
			I4:=Yr + 2000
		Else
			I4:=Yr + 1900 
		Endif
		I4:=I4*365
		If Mo > 0 and Mo < 13 Then
			I4:=I4+Dayx(Mo)
		Endif
		I4:=I4+Da
		Date2Days:=I4
Pend

Begin
	WriteLn('|CL|06==|14[|13'+ProgName+ ' |08a Mystic BBS 1.07.3 mpl, |06by ' + ProgAuth + '|CR')
	WriteLn('|06==|14[|11The Following new file areas ')
	WriteLn('|06==|14[|11have been added since your last visit.|CR')
	InitVars				# Initialize Variables
	Day0:=Date2Days('01/01/80')
	FindNewFBs				# See if there are any new file bases
	WeedOut					# See if there are any deleted file bases
	fOpen(1,Text,Reset,F1)
	Found:=0
	While not eof(1)
		fReadLn(1,TFBFile)
		fReadLn(1,TDateT)
		Day1:=Date2Days(ULastOn)
		Day2:=Date2days(TDateT)
		if Day1 <= Day2 and Day2 <> Day0 Then
			I1:=1
			While GetFBase(I1)
				If TFBFile = FBFilename and ACS(FBACS)
				 	WriteLn('|04--|12(|14' + TDateT + '|12)|04--|11' + FBName)
					Found:=1
				Endif
				I1:=I1+1
			Wend
		endif
	Wend
	fClose(1)
	If Found = 0 then
		WriteLn('|01xx|09[|12None!')
	Else
		Write('|CR|PA')
	Endif
End
